//-------------------------------------------------------------------
//	File:		   light.c
//	Comments:   by George Ziniewicz
//-------------------------------------------------------------------

#include "light.h"

//--------------------------------------------------------------------------------------

Light::Light() {
	x=0; y=0; z=0; radius=2;
	amb=.25; diff=.5; spec=.75; refl=.99;
	exponent=1; cutoff=180;
	r=1; g=1; b=1; inten=1;
	return;
};

Light::~Light() {};

//--------------------------------------------------------------------------------------

void Light::position(float inx, float iny, float inz) {
	x=inx;
	y=iny;
	z=inz;
}

//--------------------------------------------------------------------------------------

void Light::fixed(int lightn, float x, float y, float z, float iinten, float brace) {
   int i;
   int linfo[]={GL_LIGHT0,GL_LIGHT1,GL_LIGHT2,GL_LIGHT3,
                GL_LIGHT4,GL_LIGHT5,GL_LIGHT6,GL_LIGHT7};
	GLfloat amba[4]={0,0,0,1.}, diffa[4]={0,0,0,1.},
		   speca[4]={0,0,0,1.}, refla[4]={0,0,0,1.},
		    pos[4]={0,0,0,1.},  dir[4]={0,0,0,1.};
	float c[3];

	c[0]=r;
	c[1]=g;
	c[2]=b;

	for (i=0; i<3; i++) {
		 amba[i]= amb *inten*iinten*c[i]; diffa[i]= diff*inten*iinten*c[i]; 
		speca[i]= spec*inten*iinten*c[i]; refla[i]= refl*inten*iinten*c[i];
	}
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT,amba);
	glMaterialfv(  GL_FRONT_AND_BACK,GL_SPECULAR,refla);

	glLightfv(linfo[lightn],GL_AMBIENT, amba);
	glLightfv(linfo[lightn],GL_DIFFUSE, diffa);
	glLightfv(linfo[lightn],GL_SPECULAR,speca);

	glLightf(linfo[lightn],GL_SPOT_EXPONENT,exponent);
	glLightf(linfo[lightn],GL_SPOT_CUTOFF,cutoff);
	glPushMatrix();
		//glLoadIdentity(); //if viewer relative
		glTranslatef(x,y,z);
		glLightfv(linfo[lightn],GL_POSITION,       pos);
		glLightfv(linfo[lightn],GL_SPOT_DIRECTION, dir);
		glPopMatrix();
	glEnable(linfo[lightn]);
	return;
}

//---------------------------------------------------------------------------
/*
void draw_lightn(int lightn, float lightradius) {
   float size=.1;
   int index;
   
   index=50+lightn*5; // light counters start at 20, w/ 5 elements
   glColor3f(1,1,1);
   glEnable(GL_TEXTURE_2D);
   glEnable(GL_BLEND);
   //tex_sun.Use();
  
   glPushMatrix();
      glRotatef(count(index+3,5,720,0), 0,1,0);
      glRotatef(count(index+4,5,720,0), 1,0,0);
      glTranslatef(0,0,lightradius);
      
     	glBegin(GL_QUADS);
         glTexCoord2f(0,0); glVertex2f(-size,-size);
         glTexCoord2f(0,1); glVertex2f(-size, size);
         glTexCoord2f(1,1); glVertex2f( size, size);
         glTexCoord2f(1,0); glVertex2f( size,-size);
         glEnd();
      glPopMatrix();
      
   glDisable(GL_TEXTURE_2D);
   glDisable(GL_BLEND);
   return;
   }

//---------------------------------------------------------------------------
*/

