#if !defined(main_h)
#define      main_h

#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <iostream.h>
#include <fstream.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glut.h>
#include <mmsystem.h>

// generic defines ---------------------------------------------------------------------
#define  pi1 3.141592654f
#define  pi2 6.283185307f
#define  rc  0.017453292f
#define  pih 1.570796327f

#define NEARZ 1
#define FARZ 2000
#define maxoption 10
#define maximage 8

// ------------------- generic globals -------------------------------------------------


//--------------------- generic protos -------------------------------------------------- 
  
bool appInit(void);
bool appRender(void);
void appShutdown(void);

// glut
void display0(void);
void display(void);
void idle(void);
void keyboard0(unsigned char key, int x, int y);
void keyboard(unsigned char key, int x, int y);
void mouseCB0(int button, int state, int x, int y);
void mouseCB(int button, int state, int x, int y);
void specialdown0(int key, int x, int y);
void specialdown(int key, int x, int y);
void motion(int x, int y);
void reshape(int w, int h);
void specialup(int key, int x, int y);
void keyboardup0(unsigned char key, int x, int y);

// this app
void init_once(void);
void init_pref(void);
void init_vars(void);
void view_this(void);
void draw_this(void);
void annot_this(void);
void draw_thing(void);
void key_this(unsigned char key);
void shutdown_this(void);

void move_keys(void);
void do_title(void);
void checkGL(void);

void particle_init(void);

void dialog_init(int ID, int mode);
void dialog_do(void);

void  doc_image(void);
void  doc_option(void);
void render_frame(float aspect);

#endif