#if !defined(snd_h)
#define      snd_h

#include <stdio.h>
#include <conio.h>
#include <windows.h>
#include <math.h>

#include "fmod.h"
#include "fmod_errors.h"

#include "object.h"
class Hardware;

//---------------------------------------------------------------------------------

class Snd{
public:		Snd();
	virtual ~Snd();

	int numDrivers, sndDriver, sndOutput, on, inited, lastChannel, frequency, type;
	int hasSound, hasHw, hasReverb;
	unsigned int caps;
	float lastTime, volume, pan, reverb, mind, maxd, worldSize,worldScale;
	Hardware *hw;
	FSOUND_SAMPLE *sample1;
	FSOUND_GEOMLIST *glist;
	FSOUND_MATERIAL *material;

	int init(void);
	void deinit(void);
	int play(const char *s);
	int play(const char *s,float x, float y, float z);
	int play(FSOUND_SAMPLE *sample);
	int play(FSOUND_SAMPLE *sample,float x, float y, float z);
	int  finish_2d(FSOUND_SAMPLE *sample);
	int  finish_3d(FSOUND_SAMPLE *sample, float x, float y, float z);
	void set_volume(float volume);
	void set_pan(float inpan);
	void set_frequency(int infrequency);

	void free_sample(FSOUND_SAMPLE *sample);

	int  open_geom(void);
	void close_geom(void);
	void make_geom_polys(void);
	void update_listener(void);
	void set_reverb(int envn);

	void set_loc(int channel, float x, float y, float z);
	void log_error(void);

	//int load_wav(const char *s, FSOUND_SAMPLE *sample);
};

//----------------------------------------------------------------------------------

#endif


