#if !defined(text_h)
#define      text_h

#include "main.h"
#include "counter.h"
#include "object.h"
#include "utility.h"
#include "texture.h"

//-------------------------------------------------------------------------------------
class Object;

class Text:public Object{
public:     Text();
	virtual ~Text();
	
	static Texture *tex;
	static Counter *counter;
	static Time *time;
	static Screen *screen;

	int   alphatest, blend, fmode;
	float xinc, inten, alphafunc, italic, endTime, duration;

	int     bend, drift, glitch, bloom;
	float   bendspeedx,   bendspeedy,   bendamplx,   bendamply;
	float  driftspeedx,  driftspeedy,  driftamplx,  driftamply;
	float glitchspeedx, glitchspeedy, glitchamplx, glitchamply;
	float  bloomspeedx,  bloomspeedy,  bloomamplx,  bloomamply;
	float fmodeamplx, fmodeamply, bloomcrawl;
	char  s[80];

	void reset(void);
	void color(float red, float green, float blue);
	void color(float red, float green, float blue, float alpha);
	void print(char *s, float x, float y, float size);

	void hold(void);
	void hold(char *ins);
	void hold(char *format, float value);
	void hold(char *format, double value);
	void hold(char *format, int value);
	void hold(char *format, char *value);
	void printHold(void);
	void f(float *inx, float *iny);

/*
	void clock(int fps);
	void checkGL(void);
*/
};
   
//-------------------------------------------------------------------------------------

class Clock:public Text{
public:		Clock();
	virtual ~Clock();

	double nextsecond;
	int framecnt, fps;

	void draw(void);
	void update(void);
};

//---------------------------------------------------------------------------------

#endif
